#include <inttypes.h>
#include <stdlib.h>
#include <stdio.h>
#include <err.h>

/*aggressively parenthesized in case precedence of 
 binary   operations is unfamiliar. */
uint32_t reverse32(const uint32_t input){
	const uint32_t mask1=5*16843009;
	const uint32_t mask2=3*16843009;
	const uint32_t mask3=3*mask1;
	const uint32_t mask4=16711935;
	const uint32_t mask5=65535;
	uint32_t bits=((input<<1) & (mask1<<1))|((input>>1) & mask1);
	bits = ((bits<<2) & (mask2<<2)) | ((bits>>2)& mask2);
	bits = ((bits<<4) & (mask3<<4)) | ((bits>>4)& mask3);
	bits = ((bits<<8) & (mask4<<8)) | ((bits>>8)& mask4);
	bits = ((bits<<16) & (mask5<<16)) | ((bits>>16)& mask5);
	return(bits);
}

/*
 * XXX KEBE SAYS cleanup the above, esp. in its constants, so it's more
 * readable.
 */

#define	MASK1	0x05050505	/* aka. 00000101000001010000010100000101 */
#define	MASK2	0x03030303	/* aka. 00000011000000110000001100000011 */
#define	MASK3	0x0f0f0f0f	/* aka. 00001111000011110000111100001111 */
#define	MASK4	0x00ff00ff	/* aka. 00000000111111110000000011111111 */
#define	MASK5	0x0000ffff	/* aka. 00000000000000001111111111111111 */

uint32_t
readable_reverse32(const uint32_t input)
{
	uint32_t retval;

	retval = ((input << 1) & (MASK1 << 1)) | ((input >> 1) & MASK1);

	retval = ((retval << 2) & (MASK2 << 2)) | ((retval >> 2) & MASK2);
	retval = ((retval << 4) & (MASK3 << 4)) | ((retval >> 4) & MASK3);
	retval = ((retval << 8) & (MASK4 << 8)) | ((retval >> 8) & MASK4);
	retval = ((retval << 16) & (MASK5 << 16)) | ((retval >> 16) & MASK5);

	return (retval);
}

int
main(int argc, char *argv[])
{
	uint32_t input;
	unsigned long longarg;
	char *endptr;

	if (argc < 2)
		err(-1, "Please gimme an argument.");

	longarg = strtoul(argv[1], &endptr, 0);
	input = longarg & 0xffffffff;
	if (input != longarg) {
		warn("Warning, 0x%lx is chopped down to 0x%" PRIx32 "\n",
		    longarg, input);
	}

	(void) printf("Original(0x%" PRIx32 ") = 0x%" PRIx32 "\n", input,
	    reverse32(input));
	(void) printf("Readable(0x%" PRIx32 ") = 0x%" PRIx32 "\n", input,
	    readable_reverse32(input));

	return (0);
}
